//***************************************
//  RC- 4.0000Mhz 
// mega8
// 				 http://startcd.narod.ru/ 
//
//***************************************

#define katod//						 .   . .

#ifdef katod
#warning "   "
#else
#warning "   "
#endif

#define	miganie //  	 ,    , .

#include <avr\io.h>
#include <avr\interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>
#include "font.h"
#include "regim.h"

#define BIT _BV

#define KEY_F		( !(PINKEY & BIT(5)) )
#define KEY_SET		( !(PINKEY & BIT(4)) )
#define KEY_PLUS	( !(PINKEY & BIT(3)) )
#define KEY_MINUS	( !(PINKEY & BIT(2)) )
#define KEY			( BIT(2)|BIT(3)|BIT(4)|BIT(5) )

#define F_ 		   (key==1)
#define SET_ 	   (key==2)
#define PLUS 	   (key==3)
#define MINUS	   (key==4)

#define PORTKEY	PORTB
#define PINKEY	PINB
#define DDRKEY	DDRB

//*******PORT*******
#define OC1A	BIT(1)
#define DDR_OC1A	DDRB
#define PORT_OC1A	PORTB

#define PORT_BUDIL	PORTB
#define DDR_BUDIL	DDRB
#define PIN_BUDILNIK	BIT(0)
#define BUDIL_OUT_ON	PORT_BUDIL|= PIN_BUDILNIK
#define BUDIL_OUT_OFF	PORT_BUDIL&=~PIN_BUDILNIK

#define PIN_TIMER		_BV(2)
#define PORT_TIMER		PORTC
#define DDR_TIMER		DDRC
#define TIMER_OUT_ON	PORT_TIMER|= PIN_TIMER
#define TIMER_OUT_OFF	PORT_TIMER&=~PIN_TIMER

#define PORTSERIAL	   	PORTD
#define DDRSERIAL	   	DDRD
#define SHIFT		7
#define STORAGE		6
#define DATA		5
#define PIN_SERIAL	   	( (1<<DATA)|(1<<SHIFT)|(1<<STORAGE) )

#define	PORTLED	   PORTD
#define	DDRLED	   DDRD

//*******PORT*******
#define	PORT_1wire 		PORTC
#define	DDR_1wire 		DDRC
#define	PIN_1wire 		PINC

#define kolvo_datchikov	2
#define	pwire0 			BIT(3)	//PC3	
#define	pwire1 			BIT(4)	//PC4	
//#define	pwire2 			BIT(2)	//PC2
//#define	pin_datchik		(pwire0|pwire1)//|pwire3)

#define _power_			BIT(5)
#define PORT_POWER_DETECT	PORTC
#define PIN_P_Dt			PINC
#define pin_power_		( PIN_P_Dt & _power_ )

#define PIN_TSTAT		_BV(0)
#define PORT_TSTAT		PORTC
#define DDR_TSTAT		DDRC
#define INIT_DDR_TSTAT	DDR_TSTAT|=PIN_TSTAT

#define PIN_HOUR		_BV(1)
#define PORT_HOUR		PORTC
#define DDR_HOUR		DDRC
#define	INIT_DDR_HOUR	DDR_HOUR|=PIN_HOUR
#define HOUR_OUT_ON		PORT_HOUR|= PIN_HOUR
#define HOUR_OUT_OFF	PORT_HOUR&=~PIN_HOUR

//-------- time_flag byte -------
#define fl_sek_1_switch			BIT(0)
#define	fl_plus					BIT(1)//  
#define	fl_sig_butt				BIT(2)//    
#define	fl_eeprom_write			BIT(3)
#define	fl_power_save			BIT(4)
#define	fl_num_on				BIT(5)


//----------corr_flag---------
#define fl_corr_znak_pl	0

//----------------------------
#define	h_sek		0
#define	h_min		1
#define	h_hour		2
#define	h_day 		3
#define	h_num		4
#define	h_month		5

#define T_SEK		0
#define T_MIN		1
#define T_HOUR		2
#define T_MIN_ON	3
#define T_HOUR_ON	4

#define TIMER_ON	3


#define ds0	0
#define ds1	1

//---time[]---
#define wire1		0
#define note		1
#define note_but	2
//#define _skan_key_	3


signed char Timer[4]; 
uint8_t	TimerGo;
unsigned char key=17, znakomesto, znakomesto_isr, regim, time_in_regim, anti_drebezg[3];
unsigned char lcd_time_switch, time_flag;
unsigned char change_light, lcd_light=5, light_isr, light_disp[]={53,50,48,45,40,35,30,15,10,2}, light_time_mig[]={9,8,7,7,6,5,5,4,4,3}, mask;
unsigned char clock_, isr_1sek_, correct, hour[6]={50,0,0,0,0,0};//hour- month,num,day,hour,min,sek
unsigned char lcd_buffer[7], bcd_num0, bcd_num1, bcd_num2, bcd_num3, bcd_num4;
unsigned char p_index, x_index, budilnik_nomer, signal, time_signal, budilnik_play_num;
unsigned char eeprom_err;
//unsigned char viewstate, time_view_buf=1, view_regim_state; 
unsigned char tempir_lsb[kolvo_datchikov], tempir_msb[kolvo_datchikov], out_1wire, count_com_1w, power_suplly_1w;
  signed char time[4];
  signed int  temperatura[kolvo_datchikov];//tmp_correct_ds[3],
  
//unsigned char 	count_note,
//				ocr1[5]={4,0,4,0,0};//, ocr1ahi, ocr1alow, ocr1ahi_but, ocr1alow_but;


struct	{
		unsigned char day_light;
		unsigned char night_light;
		unsigned char tim_c_light;
		unsigned char tim_do_light;
		unsigned char kukuschka[3];
		
		#define Count_bud	8
		unsigned char budilnik[Count_bud][4];
		unsigned char timer[5];
		int16_t porog[2];
		
		#define Count_regim	8//  
		uint8_t state_time [Count_regim];
		uint8_t state_regim[Count_regim];
		uint8_t state_skip [Count_regim];
		
		unsigned char corr_flag;
		unsigned char correction;
		unsigned int crc;
} setup;

struct current_state_view
{
	uint8_t regim;
	uint8_t time;
	uint8_t skip[Count_regim];
	uint8_t viewstate;
}	current_state_view;	

#define	ocr1ahi			0
#define	ocr1alow		1
#define	ocr1ahi_but		2
#define	ocr1alow_but	3

prog_int16_t	corr_in_lcd[51] =	{0,8,16,23,31,39,47,55,63,70,78,86,94,102,109,117,
									125,133,141,148,156,164,172,180,188,195,203,211,219,227,234,242,
									250,258,266,273,281,289,297,305,313,320,328,336,344,352,359,367,
									375,383,391};
						//corr[18]={0,4,8,12,16,20,24,28,32,36,40,44,48,52,64,80,96,112},
						//corr_in_lcd[18]={0,3,6,9,12,15,18,21,25,28,31,34,37,40,50,62,75,87};
						
const unsigned char 	num_in_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
const unsigned char 	length_note[4]={20,10,20,75}, uprav_TCCR1B[4]={1|(1<<WGM12), 0|(1<<WGM12), 1|(1<<WGM12), 0|(1<<WGM12)};

//-----------EEPROM-----------------
#define	EEPROM_ADR		0

